"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var isInteger = require("lodash/isInteger");
var isNaN = require("lodash/isNaN");
var Input_1 = require("../Input");
var p10 = function (val) { return parseInt(val, 10); };
exports.rules = {
    equals: function (target, value) { return p10(target) === p10(value); },
    'more than': function (target, value) { return p10(target) > p10(value); },
    'less than': function (target, value) { return p10(target) < p10(value); }
};
exports.validate = isInteger;
exports.normalize = function (value) {
    if (isInteger(value)) {
        return value;
    }
    var num = parseFloat(value, 10);
    if (isNaN(num)) {
        return 0;
    }
    return Math.round(value);
};
exports.Edit = function (_a) {
    var value = _a.value, onChange = _a.onChange, props = __rest(_a, ["value", "onChange"]);
    return (React.createElement(Input_1.default, __assign({}, props, { type: 'number', value: value, onChange: function (e) { return onChange(p10(e.target.value)); } })));
};
exports.Display = function (_a) {
    var data = _a.data, props = __rest(_a, ["data"]);
    return (React.createElement("div", __assign({}, props),
        React.createElement("span", null, p10(data))));
};
