"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var RegexParser = require("regex-parser");
var isString = require("lodash/isString");
var React = require("react");
var Input_1 = require("../Input");
var showdown = require("showdown");
var converter = new showdown.Converter();
var normalizeString = function (string) {
    return string || '';
};
exports.rules = {
    is: function (target, value) { return normalizeString(target) === value; },
    contains: function (target, value) { return normalizeString(target).includes(value); },
    'does not contain': function (target, value) {
        return !normalizeString(target).includes(value);
    },
    'matches RegEx': function (target, value) {
        return normalizeString(target).match(RegexParser(value));
    },
    'does not match RegEx': function (target, value) {
        return !normalizeString(target).match(RegexParser(value));
    }
};
exports.validate = function (val) { return isString(val) && val.length <= 255; };
exports.normalize = function (value) { return (value == null ? '' : value.toString()); };
exports.Edit = function (_a) {
    var onChange = _a.onChange, props = __rest(_a, ["onChange"]);
    return (React.createElement(Input_1.default, __assign({ type: 'text', onChange: function (e) { return onChange(e.target.value); } }, props)));
};
exports.Display = function (_a) {
    var data = _a.data, props = __rest(_a, ["data"]);
    return (React.createElement("div", __assign({}, props, { className: 'markdown-body', dangerouslySetInnerHTML: { __html: converter.makeHtml(data) } })));
};
