"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var styled_components_1 = require("styled-components");
var DropDownButton_1 = require("../components/DropDownButton");
var Grid_1 = require("../components/Grid");
var Divider_1 = require("../components/Divider");
var Container = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  margin: 30px;\n"], ["\n  margin: 30px;\n"])));
react_1.storiesOf('DropDownButton', module)
    .addWithInfo('Standard', function () {
    return (React.createElement(Container, null,
        React.createElement(DropDownButton_1.default, { mx: 2, primary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, secondary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, tertiary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"))));
})
    .addWithInfo('Borderless', function () {
    return (React.createElement(Container, null,
        React.createElement(DropDownButton_1.default, { mx: 2, border: false, primary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, border: false, secondary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, border: false, tertiary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, border: false, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"))));
})
    .addWithInfo('Joined', function () {
    return (React.createElement(Container, null,
        React.createElement(DropDownButton_1.default, { mx: 2, joined: true, primary: true, label: 'DropDown' },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, joined: true, secondary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, joined: true, tertiary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(DropDownButton_1.default, { mx: 2, joined: true },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"))));
})
    .addWithInfo('Alignment', function () {
    return (React.createElement(Container, null,
        React.createElement(Grid_1.Flex, { justify: 'space-between' },
            React.createElement(DropDownButton_1.default, { mx: 2, primary: true, label: React.createElement("div", null, "DropDown") },
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit.")),
            React.createElement(DropDownButton_1.default, { mx: 2, alignRight: true, secondary: true, label: React.createElement("div", null, "DropDown") },
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
                React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit.")))));
})
    .addWithInfo('Divider', function () {
    return (React.createElement(Container, null,
        React.createElement(DropDownButton_1.default, { mx: 2, primary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
            React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
            React.createElement(Divider_1.default, { color: '#c6c8c9', height: 1 }),
            React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
            React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
            React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."),
            React.createElement("div", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."))));
})
    .addWithInfo('No List Formatting', function () {
    return (React.createElement(Container, null,
        React.createElement(DropDownButton_1.default, { mx: 2, noListFormat: true, primary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement(Grid_1.Box, { p: 3 },
                React.createElement("h3", null, "Free input"),
                React.createElement("p", null, "Lorem ipsum dolor sit amet")))));
});
var templateObject_1;
